clear all
close all

foldername='manuscript_figs';

MkFig=1;
res='-r600';
Position=[0 0 1050 1250*0.50];
TitleSz=22; LblSz=24; AxSz=20;
ctP=100;

%-------------------------------------

mkdir(foldername)

%-------------------------------------

Ns=load('Ns_dat_source.txt'); Nt=load('Ns_dat_target.txt');
Es=load('Es_dat_source.txt'); Et=load('Es_dat_target.txt'); 
NNs=sqrt(length(Ns))-1; NNt=sqrt(length(Nt))-1;

Gs=zeros(NNs,NNs); Ps22=Gs; Xs=linspace(-0.1,1.1,NNs); Ys=Xs;
for ii=1:NNs
    Gs(ii,:)=((ii-1)*NNs)+(1:NNs);
end

MaxP=load('MaxMinP'); MaxP=max(MaxP);
MinP=load('MaxMinP'); MinP=max(MinP);

Gt=zeros(NNt,NNt,2); Pt22=zeros(NNt,NNt); Xt=linspace(0,1,NNt); Yt=Xt;
ct=0;
for ii=1:NNt
    for jj=1:NNt
        if (mod(ii,2)==1)
            ct=ct+1;
            Gt(ii,jj,1)=ct;
            ct=ct+1;
            Gt(ii,jj,2)=ct;
        else
            ct=ct+1;
            Gt(ii,jj,1)=ct;
            Gt(ii,jj,2)=ct;
        end
    end
end

if ctP<10
    numstr=['00' num2str(ctP)];
else
    if ctP<100
        numstr=['0' num2str(ctP)];
    else
        numstr=num2str(ctP);
    end
end
fileS=['input/Ps_' numstr '.txt']; Ps=load(fileS);
fileT=['target/Pt_' numstr '.dat']; Pt=load(fileT);
    
for ii=1:NNs
    for jj=1:NNs
        Ps22(ii,jj)=Ps(Gs(ii,jj));
    end
end
for ii=1:NNt
    for jj=1:NNt
        Pt22(ii,jj)=((Pt(Gt(ii,jj,1)))+(Pt(Gt(ii,jj,2))))/2;
    end
end
Ps22(end,end)=MaxP; Pt22(end,end)=MaxP;
Ps22(1,1)=MinP; Pt22(1,1)=MinP;
    
ha=figure(1);
set(gcf,'Position',Position)
set(0,'DefaultAxesFontSize',AxSz,'DefaultAxesFontWeight','b')
pcolor(Xs,Ys,Ps22); shading interp
hold on
plot([0 1],[0 0],'k',[0 1],[1 1],'k',[0 0],[0 1],'k',[1 1],[0 1],'k','Linewidth',2)
hold off
axis([-.1 1.1 -.1 1.1]);
%axis([0 1 0 1]);
title(['(a)' 10 'Source']);
if MkFig==1
    print(ha,'-djpeg',[foldername '/fig_A.jpeg'],res)
    close all
end

ha=figure(2);
set(gcf,'Position',Position)
set(0,'DefaultAxesFontSize',AxSz,'DefaultAxesFontWeight','b')
pcolor(Xt,Yt,Pt22); shading interp
%colorbar
axis([-.1 1.1 -.1 1.1]);
title(['(b)' 10 'Target']);
if MkFig==1
    print(ha,'-djpeg',[foldername '/fig_B.jpeg'],res)
    close all
end

%-------------------------------------

load Results


ha=figure(3);
set(gcf,'Position',Position)
set(0,'DefaultAxesFontSize',AxSz,'DefaultAxesFontWeight','b')
plot(1:180,Ft,1:180,Fs_surf,1:180,Fs,'Linewidth',2)
legend('Target','Source on Target','Source (Total)','Location','Southwest');
axis([0 180 800 2500]);
title('Forces');
if MkFig==1
    print(ha,'-djpeg',[foldername '/Forces.jpeg'],res)
    close all
end

% R2 = 0.9998

merge_compare
