      program MakeInput

      implicit none

      real t1,t2
      character (len=200) fNodeS,fElemS,fNodeT,fElemT,fPs,wrtstr
      integer NnS,NeS,NnT,NeT,NN,ii,jj,ct,fooint,io,Em(5),oo,uu,vv
      real rng,del,XX,YY,dx,fooreal
      real x0,y0,fooP,XC0,YC0,rr,Cx,Cy,Cz
      double precision pi
      real, allocatable :: NodeS(:,:),CfctS(:,:),Pfct(:)

      call CPU_Time(t1)

      fNodeS='Ns_dat_source.txt'
      fElemS='Es_dat_source.txt'
      fNodeT='Ns_dat_target.txt'
      fElemT='Es_dat_target.txt'


c ------------------------------- Make Source -------------------------------

      NN=450
      rng=1.2
      del=-0.1

      NnS=NN**2
      NeS=((NN-1)**2)
      dx=rng/(NN-1)

      ALLOCATE(NodeS(NnS,3))
      ALLOCATE(CfctS(NeS,3))
      ALLOCATE(Pfct(NeS))

      open(unit=1,file=fNodeS)
      ct=0
      YY=del-dx
      do ii=1,NN
        YY=YY+dx
        XX=del-dx
        do jj=1,NN
          ct=ct+1
          XX=XX+dx
          write(wrtstr,'(f0.6,a,f0.6,a,f0.6)') XX,',',YY,',',YY
          write(1,*) trim(wrtstr)
          NodeS(ct,1)=XX
          NodeS(ct,2)=YY
          NodeS(ct,3)=YY
        enddo
      enddo
      close(1)

      open(unit=2,file='CentS.txt')

      open(unit=1,file=fElemS)
      ct=0
      do ii=1,(NN-1)
        do jj=1,(NN-1)
          ct=ct+1
          Em(1)=4
          Em(2)=((ii-1)*NN)+jj
          Em(3)=((ii-1)*NN)+jj+1
          Em(4)=((ii)*NN)+jj
          Em(5)=((ii)*NN)+jj+1
          call elemwrite(Em,wrtstr)
          write(1,*) trim(wrtstr)

          do uu=1,3
            fooreal=0
            do vv=1,4
              fooreal=fooreal+(NodeS(Em(vv+1),uu))
            enddo
            CfctS(ct,uu)=fooreal/4
          enddo
          write(2,*) CfctS(ct,:)


        enddo
      enddo
      close(1)

      close(2)





c ------------------------------- Make Target -------------------------------

      NN=225
      rng=1.
      del=0.


      NnT=NN**2
      NeT=((NN-1)**2)*1.5
      dx=rng/(NN-1)


      open(unit=1,file=fNodeT)
      ct=0
      YY=del-dx
      do ii=1,NN
        YY=YY+dx
        XX=del-dx
        do jj=1,NN
          ct=ct+1
          XX=XX+dx
          write(wrtstr,'(f0.6,a,f0.6,a,f0.6)') XX,',',YY,',',YY
          write(1,*) trim(wrtstr)
        enddo
      enddo
      close(1)


      open(unit=1,file=fElemT)
      ct=0
      do ii=1,(NN-1)
        if (mod(ii,2)==1) then ! and target=1
          do jj=1,(NN-1)
            ct=ct+1
            Em(1)=3
            Em(2)=((ii-1)*NN)+jj
            Em(3)=((ii-1)*NN)+jj+1
            Em(4)=((ii)*NN)+jj
            Em(5)=0
            call elemwrite(Em,wrtstr)
            write(1,*) trim(wrtstr)

            ct=ct+1
            Em(1)=3
            Em(2)=((ii-1)*NN)+jj+1
            Em(3)=((ii)*NN)+jj
            Em(4)=((ii)*NN)+jj+1
            Em(5)=0
            call elemwrite(Em,wrtstr)
            write(1,*) trim(wrtstr)
          enddo
        else
          do jj=1,(NN-1)
            ct=ct+1
            Em(1)=4
            Em(2)=((ii-1)*NN)+jj
            Em(3)=((ii-1)*NN)+jj+1
            Em(4)=((ii)*NN)+jj
            Em(5)=((ii)*NN)+jj+1
            call elemwrite(Em,wrtstr)
            write(1,*) trim(wrtstr)
          enddo
        endif
      enddo
      close(1)

c ---------------------------------------------------------------------------

      pi=3.1415926535897932384626

      do oo=1,180

        call CPU_Time(t2)
        print *,oo,'/180, t=',NINT(t2-t1)

        write(fPs,'(a,i0.3,a)') 'input/Ps_',oo,'.txt'
        open(unit=1,file=fPs)

        Cx=500.+(2*oo)
        Cy=1500.-(3*oo)
        Cz=1000.
        do ii=1,NeS
          x0=CfctS(ii,2)
          y0=CfctS(ii,1)
          xx=x0+((oo/180.)*1.2)
          yy=y0+((oo/180.)*1.2)
          if (xx>1.1) then
            xx=xx-1.2
          endif
          if (yy>1.1) then
            yy=yy-1.2
          endif
          fooP=(Cx*(xx**2))+(Cy*(yy**2))
          XC0=0.5+(0.25*cos(oo*pi/90))
          YC0=0.5+(0.35*sin(oo*pi/90))
          rr=sqrt(((x0-XC0)**2)+((y0-YC0)**2))/0.1
          fooP=fooP+(5000*exp(-rr))
          write(1,*) fooP
          

        enddo
        close(1)
      enddo





      end program

c ==========================================================


      subroutine elemwrite(Em,wrtstr)

      integer, intent(in) :: Em(5)
      character (len=200), intent(out) :: wrtstr

      write(wrtstr,'(i0.0,a,i0.0,a)') Em(1),',',Em(2),','
      write(wrtstr,'(a,i0.0,a)') trim(wrtstr),Em(3),','
      write(wrtstr,'(a,i0.0,a)') trim(wrtstr),Em(4),','
      if (Em(5)==0) then
        write(wrtstr,'(a,a)') trim(wrtstr),'0'
      else
        write(wrtstr,'(a,i0.0)') trim(wrtstr),Em(5)
      endif

      end subroutine




c ==========================================================

