clear all
close all

MkFig=1;
res='-r200';
Position=[0 0 1050 1250*0.35];
TitleSz=22; LblSz=24; AxSz=20;

Ns=load('Ns_dat_source.txt'); Nt=load('Ns_dat_target.txt');
Es=load('Es_dat_source.txt'); Et=load('Es_dat_target.txt'); 
NNs=sqrt(length(Ns))-1; NNt=sqrt(length(Nt))-1;

Gs=zeros(NNs,NNs); Ps22=Gs; Xs=linspace(-0.1,1.1,NNs); Ys=Xs;
for ii=1:NNs
    Gs(ii,:)=((ii-1)*NNs)+(1:NNs);
end

MaxP=load('MaxMinP'); MaxP=max(MaxP);
MinP=load('MaxMinP'); MinP=max(MinP);

Gt=zeros(NNt,NNt,2); Pt22=zeros(NNt,NNt); Xt=linspace(0,1,NNt); Yt=Xt;
ct=0;
for ii=1:NNt
    for jj=1:NNt
        if (mod(ii,2)==1)
            ct=ct+1;
            Gt(ii,jj,1)=ct;
            ct=ct+1;
            Gt(ii,jj,2)=ct;
        else
            ct=ct+1;
            Gt(ii,jj,1)=ct;
            Gt(ii,jj,2)=ct;
        end
    end
end

mkdir figs

for ctP=1:180
    if ctP<10
        numstr=['00' num2str(ctP)];
    else
        if ctP<100
            numstr=['0' num2str(ctP)];
        else
            numstr=num2str(ctP);
        end
    end
    fileS=['input/Ps_' numstr '.txt']; Ps=load(fileS);
    fileT=['target/Pt_' numstr '.dat']; Pt=load(fileT);
    fileout=['figs/Mapping_' numstr '.jpeg']; 
    
    for ii=1:NNs
        for jj=1:NNs
            Ps22(ii,jj)=Ps(Gs(ii,jj));
        end
    end
    for ii=1:NNt
        for jj=1:NNt
            Pt22(ii,jj)=((Pt(Gt(ii,jj,1)))+(Pt(Gt(ii,jj,2))))/2;
        end
    end
    Ps22(end,end)=MaxP; Pt22(end,end)=MaxP;
    Ps22(1,1)=MinP; Pt22(1,1)=MinP;
    
    
    ha=figure(ctP);
    set(gcf,'Position',Position)
    set(0,'DefaultAxesFontSize',AxSz,'DefaultAxesFontWeight','b')

    subplot(1,2,1)
    pcolor(Xs,Ys,Ps22); shading interp
    %hold on
    %plot([0 1],[0 0],'k',[0 1],[1 1],'k',[0 0],[0 1],'k',[1 1],[0 1],'k','Linewidth',2)
    %hold off
    %axis([-.1 1.1 -.1 1.1]);
    axis([0 1 0 1]);
    title(['Source - ' num2str(ctP)]);
    
    subplot(1,2,2)
    pcolor(Xt,Yt,Pt22); shading interp
    axis([0 1 0 1]);
    title(['Target - ' num2str(ctP)]);
    if MkFig==1
        print(ha,'-djpeg',fileout,res)
        close all
    end
    
end