      program MakeTransferMatrix

      implicit none

      character (len=200) fNodeS,fElemS,fNodeT,fElemT,fPs,fPt,fTM,fParam
      integer NnS,NeS,NnT,NeT,ii,jj,kk,ct,fooint,fooint2,io,Nx,Nx2
      integer Nbig,ct2,tint
      real fooreal,fooreal2,hh,dr,minW,minW0
      real t1,t2,hcoef
      real dx1(3),dx2(3),dx3(3),Wr,DotP,nLoc(4,3)
      real, allocatable :: NodeS(:,:),NodeT(:,:)
      real, allocatable :: ElocS(:,:),ElocT(:,:)
      real, allocatable :: sumW(:),NodeLocII(:,:)
      real, allocatable :: EdirS(:,:),EdirT(:,:),WrDat(:),As(:),At(:)
      real, allocatable :: ImpactA(:,:),ImpactS(:)
      integer, allocatable :: CTfct(:),ETct(:),ESct(:),ElemDat(:)
      integer, allocatable :: ElemS(:,:),ElemT(:,:),Nst_ct(:),Nt_ct(:)

      real, allocatable :: ImpactTdat(:,:),ImpactSdat(:,:)
      integer, allocatable :: NBT(:,:),NBS(:,:)

      call CPU_Time(t1)

      fParam='Map_Parameters.txt'
      fTM='transfer_matrix.dat'
      fNodeS='Ns_dat_source.txt'
      fElemS='Es_dat_source.txt'
      fNodeT='Ns_dat_target.txt'
      fElemT='Es_dat_target.txt'


      open(unit=35,file=fParam)
        read(35,*) Nx
        read(35,*) Nx2
        read(35,*) minW0
        read(35,*) hcoef

c      Nx=5
c      Nx2=500 ! MUST be greater than Nx
c      minW0=1./10000000000.
c      hcoef=1.0

      close(35)


      open(unit=13,file='prompt.dat')


      open(unit=9,file=fElemS)
      NeS=0
      do
         read(9,*,iostat=io)
         if (io/=0) exit
         NeS=NeS+1
         end do
      close(9)

      open(unit=9,file=fNodeS)
      NnS=0
      do
         read(9,*,iostat=io)
         if (io/=0) exit
         NnS=NnS+1
         end do
      close(9)

      open(unit=9,file=fElemT)
      NeT=0
      do
         read(9,*,iostat=io)
         if (io/=0) exit
         NeT=NeT+1
         end do
      close(9)

      open(unit=9,file=fNodeT)
      NnT=0
      do
         read(9,*,iostat=io)
         if (io/=0) exit
         NnT=NnT+1
         end do
      close(9)

      allocate(NodeS(NnS,3))
      allocate(NodeT(NnT,3))
      allocate(ETct(NeT))
      allocate(ESct(NeS))
      allocate(As(NeS))
      allocate(At(NeT))
      allocate(Nst_ct(NeT))
      allocate(Nt_ct(NeS))
      allocate(WrDat(NeT))

      open(unit=9,file=fNodeS)
      do ii=1,NnS
         read(9,*) NodeS(ii,:)
      enddo
      close(9)

      open(unit=9,file=fNodeT)
      do ii=1,NnT
         read(9,*) NodeT(ii,:)
      enddo
      close(9)

c =========================================================


      open(unit=9,file=fElemS)
      do ii=1,NeS
        read(9,*) ESct(ii)
      enddo
      close(9)

      open(unit=9,file=fElemT)
      do ii=1,NeT
        read(9,*) ETct(ii)
      enddo
      close(9)

      fooint=maxval(ESct)
      allocate(ElemS(NeS,4))
      fooint=maxval(ETct)
      allocate(ElemT(NeT,4))
      allocate(NodeLocII(fooint,3))

      open(unit=9,file=fElemS)
      do ii=1,NeS
        read(9,*) fooint,ElemS(ii,:)
      enddo
      close(9)

      open(unit=9,file=fElemT)
      do ii=1,NeT
        read(9,*) fooint,ElemT(ii,:)
      enddo
      close(9)


c =========================================================

      allocate(ElocS(NeS,3))
      allocate(ElocT(NeT,3))

      do ii=1,NeS
         do jj=1,3
            fooreal=0
            do fooint=1,ESct(ii)
               fooint2=ElemS(ii,fooint)
               fooreal=fooreal+(NodeS(fooint2,jj))
            enddo
            ElocS(ii,jj)=fooreal/ESct(ii)
         enddo
      enddo

      do ii=1,NeT
         do jj=1,3
            fooreal=0
            do fooint=1,ETct(ii)
               fooint2=ElemT(ii,fooint)
               fooreal=fooreal+(NodeT(fooint2,jj))
            enddo
            ElocT(ii,jj)=fooreal/ETct(ii)
         enddo
      enddo



c =========================================================

c Calculate the area of the source and target elements

      open(unit=51,file='As.dat')
      do ii=1,NeS
         nLoc=nLoc*0
         fooint=ESct(ii)
         do jj=1,fooint
            nLoc(jj,:)=NodeS(ElemS(ii,jj),:)
         enddo
         call CalcA(fooint,nLoc,As(ii))
         write(51,*) As(ii)
      enddo
      close(51)


      open(unit=51,file='At.dat')
      do ii=1,NeT
         nLoc=nLoc*0
         fooint=ETct(ii)
         do jj=1,fooint
            nLoc(jj,:)=NodeT(ElemT(ii,jj),:)
         enddo
         call CalcA(fooint,nLoc,At(ii))
         write(51,*) At(ii)
      enddo
      close(51)

      hh=hcoef*sum(sqrt(At))/NeT

c -------------------------------------  

      ii=NeT
      nLoc=nLoc*0
      fooint=ETct(ii)
      do jj=1,fooint
         nLoc(jj,:)=NodeT(ElemT(ii,jj),:)
      enddo
      call CalcA(fooint,nLoc,At(ii))

c -------------------------------------

c =========================================================

      allocate(EdirS(NeS,3))
      allocate(EdirT(NeT,3))

      open(unit=51,file='EdirS.dat')
      do ii=1,NeS
         dx1=NodeS(ElemS(ii,1),:)-NodeS(ElemS(ii,2),:)
         dx2=NodeS(ElemS(ii,1),:)-NodeS(ElemS(ii,3),:)

         call crossprod(dx1,dx2,dx3)
         EdirS(ii,:)=dx3
         write(51,*) EdirS(ii,:)
      enddo
      close(51)


      open(unit=51,file='EdirT.dat')
      do ii=1,NeT
         dx1=NodeT(ElemT(ii,1),:)-NodeT(ElemT(ii,2),:)
         dx2=NodeT(ElemT(ii,1),:)-NodeT(ElemT(ii,3),:)
         call crossprod(dx1,dx2,dx3)
         EdirT(ii,:)=dx3
         fooreal=sqrt(sum(dx3**2))
         write(51,*) EdirT(ii,:)
      enddo
      close(51)

      write(13,*) 'Made It!'

c ==============================================================



      allocate(ImpactSdat(NeS,Nx))
      allocate(NBS(NeS,Nx))
      allocate(ImpactTdat(NeT,Nx2))
      allocate(NBT(NeT,Nx2))

      allocate(ImpactS(Nx))

      NBS=(NBS*0)+1
      do jj=1,NeS
         ImpactS=ImpactS*0.
         ct=0
         fooreal=0
         do ii=1,NeT
            dr=0
            do kk=1,3
               dr=dr+((ElocT(ii,kk)-ElocS(jj,kk))**2)
            enddo
            dr=sqrt(dr)
            Wr=exp(-2*((dr/hh)**2))
            call dotprod(EdirT(ii,:),EdirS(jj,:),DotP)
            if ((Wr*DotP)>minW0) then
            minW=minval(ImpactS)
            if ((Wr*DotP)>minW) then
               ct=minloc(ImpactS,dim=1)
               fooreal=fooreal+(Wr*DotP)
               ImpactS(ct)=Wr*DotP
               NBS(jj,ct)=ii
            endif
            endif
         enddo
         Nt_ct(jj)=Nx
         fooreal=sum(ImpactS)
         if (fooreal>0) then
            ImpactS=ImpactS/fooreal
         else
            ImpactS=ImpactS*0.
         endif
         do kk=1,Nx
            ii=NBS(jj,kk)
            ImpactSdat(jj,kk)=ImpactS(kk)*As(jj)/At(ii)
         enddo
         call CPU_Time(t2)
         tint=NINT(t2-t1)
         write(13,*) jj,'/',NeS,' - ',ct,', t = ',tint,' s'
      enddo


      Nst_ct=Nst_ct*0
      do jj=1,NeS
         call CPU_Time(t2)
         tint=NINT(t2-t1)
         write(13,*) jj,'/',NeS,', t = ',tint,' s'
         do ii=1,Nx
            if (abs(ImpactSdat(jj,ii))>0) then
            Nst_ct(NBS(jj,ii))=Nst_ct(NBS(jj,ii))+1
            NBT(NBS(jj,ii),Nst_ct(NBS(jj,ii)))=jj
            ImpactTdat(NBS(jj,ii),Nst_ct(NBS(jj,ii)))=ImpactSdat(jj,ii)
            endif
         enddo
      enddo


      WrDat=WrDat*0.
      do jj=1,NeT
         WrDat(jj)=sum(ImpactTdat(jj,:))
      enddo



      open(unit=11,file=fTM)
      write(11,*) NeT
      do ii=1,NeT
         write(11,*) ii,Nst_ct(ii),WrDat(ii)
         do jj=1,Nst_ct(ii)
            write(11,*) (jj-1),NBT(ii,jj),ImpactTdat(ii,jj)
         enddo
      enddo
      close(11)


      close(13)

      end program

c ==========================================================


c ==========================================================

      subroutine normalize(vin,vout)

      real, intent(in) :: vin(3)
      real, intent(out) :: vout(3)
      real foo
      integer ii

      foo=0.
      do ii=1,3
         foo=foo+(vin(ii)**2)
      enddo
      foo=sqrt(foo)
      vout=vin/foo


      end subroutine

c ==========================================================

      subroutine crossprod(dx1,dx2,dx3)

      real, intent(in) :: dx1(3),dx2(3)
      real, intent(out) :: dx3(3)
      real foo,dx1n(3),dx2n(3),dx3x(3)
      integer ii

      call normalize(dx1,dx1n)
      call normalize(dx2,dx2n)

      dx3x(1)=(dx1n(2)*dx2n(3))-(dx1n(3)*dx2n(2))
      dx3x(2)=(dx1n(3)*dx2n(1))-(dx1n(1)*dx2n(3))
      dx3x(3)=(dx1n(1)*dx2n(2))-(dx1n(2)*dx2n(1))

      call normalize(dx3x,dx3)

c      dx3=dx3x

      end subroutine


c ==========================================================

      subroutine dotprod(dx1,dx2,out)

      real, intent(in) :: dx1(3),dx2(3)
      real, intent(out) :: out
      real foo,dx1n(3),dx2n(3),dx3x(3)
      integer ii

      call normalize(dx1,dx1n)
      call normalize(dx2,dx2n)

      foo=0
      do ii=1,3
         foo=foo+(abs(dx1n(ii)*dx2n(ii)))
      enddo
      out=sqrt(foo)


      end subroutine

c ==========================================================

      subroutine CalcA(Nn,nLoc,Aout)

      integer, intent(in) :: Nn
      real, intent(in) :: nLoc(4,3)
      real, intent(out) :: Aout
      real fooreal,A,AA,dx1(3),dx2(3),dx3(3),C(3),Xdat(3,3)
      real Adat3(3)
      integer uu,vv,ww,ii,jj,pp(2)

      if (Nn==3) then

        do ii=1,3
           fooreal=0
           do jj=1,3
              Xdat(jj,ii)=nLoc(jj,ii)
           enddo
        enddo
        call CalcAtri(Xdat,A)


      elseif (Nn==4) then
      
        do jj=2,4

          if (jj==2) then
            pp(1)=3
            pp(2)=4
          elseif (jj==3) then
            pp(1)=2
            pp(2)=4
          elseif (jj==4) then
            pp(1)=2
            pp(2)=3
          endif


          A=0
          do ii=1,2
            Xdat(1,:)=nLoc(1,:)
            Xdat(2,:)=nLoc(jj,:)
            Xdat(3,:)=nLoc(pp(1),:)
            call CalcAtri(Xdat,AA)
            A=A+AA
          enddo
          Adat3(jj-1)=A

        enddo
        A=maxval(Adat3)

      endif


      Aout=A


      end subroutine

c ==========================================================

      subroutine CalcAtri(Xdat,Aout)

      real, intent(in) :: Xdat(3,3)
      real, intent(out) :: Aout
      real fooreal,A,AA,dx1(3),dx2(3),dx3(3),C(3)
      integer uu,vv,ww,ii

      do ii=1,3
         fooreal=0
         do jj=1,3
            fooreal=fooreal+Xdat(jj,ii)
         enddo
         C(ii)=fooreal/3
      enddo


      A=0
      do uu=1,3
         vv=uu+1
         if (vv==4) then
            vv=1
         endif
         dx1=C-Xdat(uu,:)
         dx2=C-Xdat(vv,:)
         dx3(1)=(dx1(2)*dx2(3))-(dx1(3)*dx2(2))
         dx3(2)=(dx1(3)*dx2(1))-(dx1(1)*dx2(3))
         dx3(3)=(dx1(1)*dx2(2))-(dx1(2)*dx2(1))
         AA=0
         do ww=1,3
            AA=AA+(dx3(ww)**2)
         enddo
         A=A+(0.5*sqrt(AA))
      enddo
      Aout=A

      end subroutine
